<template>
  <div class="content">
    <board-list @create="handleCreate">
      <app-board
        v-for="(board, index) in boards"
        :index="index"
        :key="index"
        :board="board"
        @update="handleUpdate"
        @delete="handleDelete"
        @sort="handleSort"
      />
    </board-list>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import BoardList from "../templates/BoardList.vue";
import AppBoard from "../components/Board.vue";
import { Board, Card, List, LocalDatabase } from "@/core/database";
import {
  BoardRepository,
  CardRepository,
  ListRepository,
  TodoRepository,
} from "@/core/repositories";
import { SubSink } from "subsink";

export default defineComponent({
  components: { BoardList, AppBoard },
  created() {
    LocalDatabase.getInstance().then(async (db) => {
      this.boardRepository = BoardRepository.getInstance(db);
      this.listRepository = ListRepository.getInstance(db);
      this.cardRepository = CardRepository.getInstance(db);
      this.todoRepository = TodoRepository.getInstance(db);
      const boardObservable = await this.boardRepository.watchAllItems();
      this.subSink.sink = boardObservable.subscribe((boards) => {
        if (boards) {
          this.boards = boards;
        }
      });
    });
  },
  data() {
    return {
      open: true,
      boardRepository: {} as BoardRepository,
      listRepository: {} as ListRepository,
      cardRepository: {} as CardRepository,
      todoRepository: {} as TodoRepository,
      boards: [] as Board[],
      subSink: new SubSink(),
    };
  },
  methods: {
    async handleCreate(newBoard: Board) {
      try {
        await this.boardRepository.insertItem(newBoard);
      } catch (error) {
        console.log(error);
      }
    },
    async handleUpdate(updatedBoard: Board) {
      try {
        await this.boardRepository.updateItem(updatedBoard);
      } catch (error) {
        console.log(error);
      }
    },
    async handleDelete(boardToDelete: Board) {
      try {
        const lists = await this.listRepository.getAllItems(
          "boardId",
          boardToDelete.id
        );
        if (lists) {
          const promises: Promise<void>[] = [];
          for (let index = 0; index < lists.length; index++) {
            const list = lists[index];
            promises.push(this.handleDeleteBoardCardList(list));
          }
          await Promise.all(promises);
        }
        await this.boardRepository.deleteItem(boardToDelete);
      } catch (error) {
        console.log(error);
      }
    },
    async handleDeleteBoardCardList(listToDelete: List) {
      try {
        const cards = await this.cardRepository.getAllItems(
          "listId",
          listToDelete.id
        );
        if (cards) {
          const promises: Promise<void>[] = [];
          for (let index = 0; index < cards.length; index++) {
            const card = cards[index];
            promises.push(this.handleDeleteBoardCard(card));
          }
          await Promise.all(promises);
        }
        await this.listRepository.deleteItem(listToDelete);
      } catch (error) {
        console.log(error);
      }
    },
    async handleDeleteBoardCard(cardToDelete: Card) {
      try {
        const todos = await this.todoRepository.getAllItems(
          "cardId",
          cardToDelete.id
        );
        if (todos) {
          const promises: Promise<void>[] = [];
          for (let index = 0; index < todos.length; index++) {
            const todo = todos[index];
            promises.push(this.todoRepository.deleteItem(todo));
          }
          await Promise.all(promises);
        }
        await this.cardRepository.deleteItem(cardToDelete);
      } catch (error) {
        console.log(error);
      }
    },
    handleSort(operation: {
      index: number;
      direction: "left" | "right";
      board: Board;
    }) {
      // TODO: Create Board
    },
  },
  unmounted() {
    this.subSink.unsubscribe();
  },
});
</script>

<style scoped>
.content {
  width: 100%;
  max-width: 100%;
  padding-top: 2rem;
  padding-left: 1rem;
  padding-right: 1rem;
  position: relative;
  height: 100%;
}

@media (min-width: 768px) {
  .content {
    max-width: 670px;
    margin-top: 3rem;
  }
}

@media (min-width: 992px) {
  .content {
    max-width: 1015px;
  }
}
</style>
